## ros-noetic-pointgrey-camera-driver 0.15.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(pointgrey_camera_driver)

find_package(catkin REQUIRED COMPONENTS
  camera_info_manager diagnostic_updater dynamic_reconfigure
  image_exposure_msgs image_transport nodelet roscpp sensor_msgs
  wfov_camera_msgs
)

generate_dynamic_reconfigure_options(
  cfg/PointGrey.cfg
)

catkin_package(CATKIN_DEPENDS
  image_exposure_msgs nodelet roscpp sensor_msgs wfov_camera_msgs
)

# If flycapture is already present, use the found version. If not, download it.
# We can't resolve this dependency using the usual rosdep means because
# the Point Grey EULA prohibits redistributing the headers or the packages which
# contains them. We work around this by downloading the archive directly from
# their website during this step in the build process.
find_library(POINTGREY_LIB NAMES libflycapture.so.2 flycapture)
find_path(POINTGREY_INCLUDE_DIR NAMES flycapture/FlyCapture2.h)
file(GLOB_RECURSE POINTGREY_HEADER ${POINTGREY_INCLUDE_DIR}*/flycapture/FlyCapture2.h ${CMAKE_CURRENT_BINARY_DIR}/usr/include*/flycapture/FlyCapture2.h)

if(NOT POINTGREY_LIB OR NOT POINTGREY_HEADER)
  # flycapture not present, must download.
  message(STATUS "libflycapture not found in system library path")
  include(cmake/DownloadFlyCap.cmake)
  download_flycap(POINTGREY_LIB POINTGREY_INCLUDE_DIR)
  message(STATUS "libflycapture library: ${POINTGREY_LIB}")
  message(STATUS "libflycapture include: ${POINTGREY_INCLUDE_DIR}")
else()
  string(FIND "${POINTGREY_LIB}" "${CATKIN_DEVEL_PREFIX}" SUBSTR_INDEX)
  if(${SUBSTR_INDEX} EQUAL 0)
    # found flycapture, but it's already in our build space; we're reconfiguring.
    message(STATUS "libflycapture found in: ${POINTGREY_LIB}")
    set(POINTGREY_INCLUDE_DIR "${CMAKE_CURRENT_BINARY_DIR}/usr/include")
  else()
    # copy it into the build directory/resolving all symlinks
    message(STATUS "libflycapture found in system library path")
    message(STATUS "libflycapture library: ${POINTGREY_LIB}")

    get_filename_component(REAL_FLYCAPTURE ${POINTGREY_LIB} REALPATH)
    get_filename_component(POINTGREY_LIB ${POINTGREY_LIB} NAME)
    set(POINTGREY_LIB "${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_LIB_DESTINATION}/${POINTGREY_LIB}")

    configure_file(${REAL_FLYCAPTURE} ${POINTGREY_LIB} COPYONLY)
    message(STATUS "libflycapture copied from: ${REAL_FLYCAPTURE} into ${POINTGREY_LIB}")
  endif()
endif()

include_directories(include ${POINTGREY_INCLUDE_DIR} ${catkin_INCLUDE_DIRS})

add_library(PointGreyCamera src/PointGreyCamera.cpp)
target_link_libraries(PointGreyCamera ${POINTGREY_LIB} ${catkin_LIBRARIES})
add_dependencies(PointGreyCamera ${PROJECT_NAME}_gencfg ${catkin_EXPORTED_TARGETS})

add_library(PointGreyCameraNodelet src/nodelet.cpp)
target_link_libraries(PointGreyCameraNodelet PointGreyCamera ${catkin_LIBRARIES})
add_dependencies(PointGreyCameraNodelet ${catkin_EXPORTED_TARGETS})

add_library(PointGreyStereoCameraNodelet src/stereo_nodelet.cpp)
target_link_libraries(PointGreyStereoCameraNodelet PointGreyCamera ${catkin_LIBRARIES})
add_dependencies(PointGreyStereoCameraNodelet ${catkin_EXPORTED_TARGETS})

add_executable(pointgrey_camera_node src/node.cpp)
target_link_libraries(pointgrey_camera_node PointGreyCamera ${catkin_LIBRARIES})
set_target_properties(pointgrey_camera_node
                      PROPERTIES OUTPUT_NAME camera_node PREFIX "")
add_dependencies(pointgrey_camera_node ${catkin_EXPORTED_TARGETS})

add_executable(pointgrey_stereo_node src/stereo_node.cpp)
target_link_libraries(pointgrey_stereo_node PointGreyCamera ${catkin_LIBRARIES})
set_target_properties(pointgrey_stereo_node
                      PROPERTIES OUTPUT_NAME stereo_node PREFIX "")
add_dependencies(pointgrey_stereo_node ${catkin_EXPORTED_TARGETS})

add_executable(pointgrey_list_cameras src/list_cameras.cpp)
target_link_libraries(pointgrey_list_cameras PointGreyCamera ${catkin_LIBRARIES})
set_target_properties(pointgrey_list_cameras
                      PROPERTIES OUTPUT_NAME list_cameras PREFIX "")
add_dependencies(pointgrey_list_cameras ${catkin_EXPORTED_TARGETS})

install(TARGETS
  PointGreyCamera
  PointGreyCameraNodelet
  PointGreyStereoCameraNodelet
  pointgrey_camera_node
  pointgrey_list_cameras
  pointgrey_stereo_node
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

# Redistributing the flycapture .so file is permitted by the SDK EULA:
# http://www.ptgrey.com/support/kb/data/PGR-FlyCap-SDK-LA.pdf
install(FILES ${POINTGREY_LIB} DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})

install(FILES nodelet_plugins.xml DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION} )

install(DIRECTORY launch DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

if (CATKIN_ENABLE_TESTING)
  find_package(roslaunch REQUIRED)
  roslaunch_add_file_check(launch/bumblebee.launch)
  roslaunch_add_file_check(launch/camera.launch)
  roslaunch_add_file_check(launch/stereo.launch)

  find_package(roslint REQUIRED)
  roslint_cpp()
endif()

=== debian/changelog ===
ros-noetic-pointgrey-camera-driver (0.15.1-1focal) focal; urgency=high



 -- Mike Purvis <mpurvis@clearpathrobotics.com>  Wed, 12 Jan 2022 05:00:00 -0000

ros-noetic-pointgrey-camera-driver (0.15.0-1focal) focal; urgency=high

  * [pointgrey_camera_driver] Added support for Focal. Updated CI for Noetic.
  * Fix the script & cmake file so that the archives are downloaded & unpacked correctly
  * Fix the flycap download script to work with Python3
  * Contributors: Chris I-B, Chris Iverach-Brereton, Tony Baltovski

 -- Mike Purvis <mpurvis@clearpathrobotics.com>  Thu, 05 Nov 2020 05:00:00 -0000

ros-noetic-pointgrey-camera-driver (0.14.1-1focal) focal; urgency=high

  * [pointgrey_camera_driver] Added future for ARM builds.
  * Update 60-pgr.rules
    Added another common vendorID
  * Contributors: Jeff Schmidt, Tony Baltovski

 -- Mike Purvis <mpurvis@clearpathrobotics.com>  Tue, 05 May 2020 04:00:00 -0000

ros-noetic-pointgrey-camera-driver (0.14.0-1focal) focal; urgency=high

  * [pointgrey_camera_driver] Switched bionic to amd64.
  * Use path.join instead of manually inserting a /
  * Whitespace cleanup
  * Add the crunch-bang python line so Atom's syntax highlighting plays nicely
  * Rewrite the download_flycap script so that it downloads packages from the correct endpoint. Drop support for Trusty, add future support for Bionic
  * Add messages as build dependencies for driver executables (#153 <https://github.com/ros-drivers/pointgrey_camera_driver/issues/153>)
  * update to use non deprecated pluginlib macro (#150 <https://github.com/ros-drivers/pointgrey_camera_driver/issues/150>)
  * Contributors: Chris I-B, Kevin Allen, Mikael Arguedas, Tony Baltovski

 -- Mike Purvis <mpurvis@clearpathrobotics.com>  Fri, 03 Apr 2020 04:00:00 -0000

ros-noetic-pointgrey-camera-driver (0.13.4-1focal) focal; urgency=high

  * Build jessie binaries with the legacy SDK as well.
  * Contributors: Mike Purvis

 -- Mike Purvis <mpurvis@clearpathrobotics.com>  Thu, 26 Oct 2017 04:00:00 -0000

ros-noetic-pointgrey-camera-driver (0.13.3-1focal) focal; urgency=high

  * Assume current library version for all OSes other than trusty. (#146 <https://github.com/ros-drivers/pointgrey_camera_driver/issues/146>)
  * Contributors: Mike Purvis

 -- Mike Purvis <mpurvis@clearpathrobotics.com>  Tue, 03 Oct 2017 04:00:00 -0000

ros-noetic-pointgrey-camera-driver (0.13.2-1focal) focal; urgency=high

  * Adding camera consistency exception. (#142 <https://github.com/ros-drivers/pointgrey_camera_driver/issues/142>)
  * Use find_path to look for system headers. (#139 <https://github.com/ros-drivers/pointgrey_camera_driver/issues/139>)
  * Added support to RGB8 pixel format and controls for sharpness and saturation (#116 <https://github.com/ros-drivers/pointgrey_camera_driver/issues/116>)
    * Added support to RGB8 pixel format and controls for sharpness and saturation
    * removed whitespaces and reverted changes to camera launch
  * Consolidate udev rules. (#131 <https://github.com/ros-drivers/pointgrey_camera_driver/issues/131>)
  * Require flycapture library and header files (#112 <https://github.com/ros-drivers/pointgrey_camera_driver/issues/112>)
  * Add multi-release support, bump SDK to 2.11.3.121 for xenial and 2.9.3.43 for trusty (#127 <https://github.com/ros-drivers/pointgrey_camera_driver/issues/127>)
  * Contributors: Bei Chen Liu, Mike Purvis, Mohammed Al-Qizwini, Vitor Matos, kmhallen

 -- Mike Purvis <mpurvis@clearpathrobotics.com>  Thu, 28 Sep 2017 04:00:00 -0000

ros-noetic-pointgrey-camera-driver (0.13.1-1focal) focal; urgency=high

  * Add flycapture2 lib download rule for aarch64(e.g. Jetson TX1) (#93 <https://github.com/ros-drivers/pointgrey_camera_driver/issues/93>)
  * Make flycap d/l logic work on re-build. (#109 <https://github.com/ros-drivers/pointgrey_camera_driver/issues/109>)
  * Fix missing roslaunch dep, package format 2.

 -- Mike Purvis <mpurvis@clearpathrobotics.com>  Wed, 19 Apr 2017 04:00:00 -0000

ros-noetic-pointgrey-camera-driver (0.13.0-1focal) focal; urgency=high

  * Adding param to provide path to serial location.
  * Fix flycapture install when using local copy.
  * Fix thread leaking issue.
  * Added stereo launch file and enabled roslaunch checkes for all launch files.
  * Enabling GigE packet resend by default (#97 <https://github.com/ros-drivers/pointgrey_camera_driver/issues/97>)
  * Enabling 16bit Bayer format (#98 <https://github.com/ros-drivers/pointgrey_camera_driver/issues/98>)
  * Allow strobe shorter than 1ms (#99 <https://github.com/ros-drivers/pointgrey_camera_driver/issues/99>)
  * Add option to strobe on GPIO2. (#91 <https://github.com/ros-drivers/pointgrey_camera_driver/issues/91>)
  * Added Format7_Mode5 and Format7_Mode7 options for Video Modes. (#90 <https://github.com/ros-drivers/pointgrey_camera_driver/issues/90>)
  * Improve white balance initialisation and logic. (#95 <https://github.com/ros-drivers/pointgrey_camera_driver/issues/95>)
  * Added Format7_Mode4 option for Video Modes. (#87 <https://github.com/ros-drivers/pointgrey_camera_driver/issues/87>)
  * Added new camera model (#86 <https://github.com/ros-drivers/pointgrey_camera_driver/issues/86>)
  * Added the option to use the format7_mode4. (#84 <https://github.com/ros-drivers/pointgrey_camera_driver/issues/84>)
  * Adding string parameter fallback. (#81 <https://github.com/ros-drivers/pointgrey_camera_driver/issues/81>)
  * Contributors: Benjamin Blumer, Brian Holt, Devon Ash, Enrique Fernandez, Kazumi Malhan, Léonard Gérard, Mike O'Driscoll, Nicola Castaman, Tony Baltovski, Tracey Spicer, fabrizioschiano

 -- Mike Purvis <mpurvis@clearpathrobotics.com>  Fri, 17 Mar 2017 04:00:00 -0000

ros-noetic-pointgrey-camera-driver (0.12.2-1focal) focal; urgency=high

  * Reconnect on error (#79 <https://github.com/ros-drivers/pointgrey_camera_driver/issues/79>)
  * Update to FlyCapture v2.9.3.43 (#65 <https://github.com/ros-drivers/pointgrey_camera_driver/issues/65>)


=== debian/control ===
Source: ros-noetic-pointgrey-camera-driver
Section: misc
Priority: optional
Maintainer: Mike Purvis <mpurvis@clearpathrobotics.com>
Build-Depends: debhelper (>= 9.0.0), curl, dpkg, libcurl4-openssl-dev, libraw1394-dev, libusb-1.0-0-dev, ros-noetic-camera-info-manager, ros-noetic-catkin, ros-noetic-diagnostic-updater, ros-noetic-dynamic-reconfigure, ros-noetic-image-exposure-msgs, ros-noetic-image-transport, ros-noetic-nodelet, ros-noetic-roscpp, ros-noetic-roslaunch, ros-noetic-roslint, ros-noetic-sensor-msgs, ros-noetic-wfov-camera-msgs
Homepage: http://ros.org/wiki/pointgrey_camera_driver
Standards-Version: 3.9.2

Package: ros-noetic-pointgrey-camera-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libraw1394-dev, libusb-1.0-0-dev, ros-noetic-camera-info-manager, ros-noetic-diagnostic-updater, ros-noetic-dynamic-reconfigure, ros-noetic-image-exposure-msgs, ros-noetic-image-proc, ros-noetic-image-transport, ros-noetic-nodelet, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-stereo-image-proc, ros-noetic-wfov-camera-msgs
Description: Point Grey camera driver based on libflycapture2.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-pointgrey-camera-driver//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
